<?php
/**
* http://www.phpbb-es.com/foro/guias-phpbb3/solucion-caracteres-extranos-al-convertir-migrar-trasladar-t25331.html
**/

define('IN_PHPBB', true);
// Enable the debug mode
if (!defined('DEBUG'))
{
	@define('DEBUG', true);
}
// Enable the full debug mode
if (!defined('DEBUG_EXTRA'))
{
	@define('DEBUG_EXTRA', true);
}
// Include files
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
require($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();
// End session management

// Have they authenticated (again) as an admin for this session?
if (!isset($user->data['session_admin']) || !$user->data['session_admin'])
{
	login_box('', $user->lang['LOGIN_ADMIN_CONFIRM'], $user->lang['LOGIN_ADMIN_SUCCESS'], true, false);
}

// Is user any type of admin? No, then stop here, each script needs to
// check specific permissions but this is a catchall
if (!$auth->acl_get('a_'))
{
	trigger_error('NO_ADMIN');
}

// application/xhtml+xml not used because of IE
header('Content-type: text/html; charset=UTF-8');

header('Cache-Control: private, no-cache="set-cookie"');
header('Expires: 0');
header('Pragma: no-cache');

	static $charset = array();

	if (empty($charset))
	{
		$charset = array(
			'from'	=> array("ƒÂ",	"Ã¡",	"Ã©",	"Ã-",	"Ã³",	"Ãº",	"Ã±",	"Â¿",	'Ã',	"Â´",	"Ã‰",	"Ã“",	"Â©",	"Â¡",	"Ã‘",	"Ã€",	"Ã¨",	"Ã¨",	"Ã",	"Ã’",	"Ã²",	"Âª"),
			'to'	=> array('',	'á',	'é',	'í',	'ó',	'ú',	'ñ',	'¿',	'Á',	'Á',	'É',	'Ó',	'©',	'¡',	'Ñ',	'À',	'È',	'è',	'í',	'Ò',	'ò',	"º"),
		);
	}

	$tables = array(
		'phpbb_forums' => array(
			'id' => 'forum_id',
			'column' => array(
				'forum_name',
				'forum_desc',
				'forum_parents',
			),
		),
		'phpbb_topics' => array(
			'id' => 'topic_id',
			'column' => array(
				'topic_title',
				'topic_last_post_subject',
				'topic_last_poster_name',
			),
		),
		'phpbb_posts' => array(
			'id' => 'post_id',
			'column' => array(
				'post_subject',
				'post_text',
			),
		),
		'phpbb_users' => array(
			'id' => 'user_id',
			'column' => array(
				'user_sig',
				'username',
				'username_clean',
				'user_from',
				'user_occ',
				'user_interests',
			),
		),
		'phpbb_banlist' => array(
			'id' => 'ban_id',
			'column' => array(
				'ban_reason',
				'ban_give_reason',
			),
		),
		'phpbb_drafts' => array(
			'id' => 'draft_id',
			'column' => array(
				'draft_message',
			),
		),
		'phpbb_extension_groups' => array(
			'id' => 'group_id',
			'column' => array(
				'group_name',
			),
		),
		'phpbb_groups' => array(
			'id' => 'group_id',
			'column' => array(
				'group_name',
				'group_desc',
			),
		),
		'phpbb_lang' => array(
			'id' => 'lang_id',
			'column' => array(
				'lang_local_name',
			),
		),
		'phpbb_log' => array(
			'id' => 'log_id',
			'column' => array(
				'log_data',
			),
		),
		'phpbb_moderator_cache' => array(
			'id' => 'forum_id',
			'column' => array(
				'username',
			),
		),
		'phpbb_poll_options' => array(
			'id' => 'poll_option_id',
			'column' => array(
				'poll_option_text',
			),
		),
		'phpbb_privmsgs' => array(
			'id' => 'msg_id',
			'column' => array(
				'message_text',
			),
		),
		'phpbb_ranks' => array(
			'id' => 'rank_id',
			'column' => array(
				'rank_title',
			),
		),
		'phpbb_reports' => array(
			'id' => 'report_id',
			'column' => array(
				'report_text',
			),
		),
		'phpbb_reports_reasons' => array(
			'id' => 'reason_id',
			'column' => array(
				'reason_description',
			),
		),
	);

	foreach ($tables as $table => $table_data)
	{
		foreach ($table_data['column'] as $row)
		{
		#	print_r("<hr />table=($table) - row=($row) id=(".$table_data['id'].")<br />");
			find_character($table, $row, $table_data['id']);
		}
	}
	print_r("<br />FIN");

/**
* En este preoceso buscmos en una tabla y en determinadas columnas
* si existen caracteres que se deban cambiar
*
* @param (string) $table = Nombre de la tabla
* @param (string) $row = Nombre de la columna a buscar
* @param (string) $id = Nombre de la columna índice en esta tabla
**/
function find_character(&$table, &$row, &$id)
{
	global $db;
	global $charset;

	// Verificamos el prefijo de la tabla para esta tabla en particular
	$table = get_table_name($table);

	$sql = 'SELECT ' . $row . ', ' . $id . '
		FROM ' . $table;
	$result = $db->sql_query($sql);

	// Recorremos las diferentes entradas a esta tabla
	while ($rowset = $db->sql_fetchrow($result))
	{
		// Recorremos los caracteres que están mal
		foreach ($charset['from'] as $from => $character)
		{
			// Si al menos 1 caracter fué encontrado en esta tabla y en esta columna, hacemos el cambio y continuamos con la proxima tabla/columna
			if ($pos = strpos($rowset[$row], $charset['from'][$from]) !== false)
			{
				$content = change_character($rowset[$row]);

				if ($row == 'post_text' || $row == 'draft_message' || $row == 'message_text')
				{
					$uid = '[0-9a-z]{5,}';

					if (preg_match("#\[quote=\"(.*?)\"?\:$uid\]#is", $content))
					{
						$content = preg_replace("#\[quote=\"(.*?)\"\:($uid)?\]#is", "[quote=&quot;$1&quot;:$2]", $content);
					}					
				}
				print_r("table=($table) =>  row=($row) :: row_id=(".$rowset[$id].") : id=($id)<br />");
				update_table_row($table, $row, $content, $rowset[$id], $id);
			//	break;
			}
		}
	}
	$db->sql_freeresult($result);
}

/**
*Cambiamos los caracteres extraños por sus correspondientes
*
* @param (string) $content = Texto donde se encuentran los catacteres a cambiar
* @return (string) $content = Texto con los catacteres cambiados
**/
function change_character(&$content)
{
	global $charset;

	$content = str_replace($charset['from'], $charset['to'], $content);
	$content = htmlspecialchars_decode($content);
	$content = utf8_normalize_nfc($content);
	return $content;
}

/**
* Actualizamos la columna dada, en la tabla dada 
*
* @param (string) $table = Nombre de la tabla
* @param (string) $row = Nombre de la columna a buscar
* @param (string) $content = Texto con los catacteres cambiados
* @param (int) $row_id = el ID del registro a cambiar
* @param (string) $id = Nombre de la columna índice en esta tabla
**/
function update_table_row(&$table, &$row, &$content, &$row_id, &$id)
{
	global $db;

	$sql_update = 'UPDATE ' . $table . "
		SET $row = '" .  $db->sql_escape($content) . "'
		WHERE $id = " . (int) $row_id;
		print_r("SQL=($sql_update)<hr />");
	$db->sql_query($sql_update);
}

/**
* Get the real table name
* @param string $table_name The table name to get the real table name from
**/
function get_table_name(&$table_name)
{
	global $table_prefix;

//	$table_prefix = 'phpbb_3';

	static $constants = NULL;

	if (is_null($constants))
	{
		$constants = get_defined_constants();
	}

	/**
	* only do the replace if the table prefix is not already present
	* this is required since UMIL supports specifying a table via phpbb_foo
	* (where a replace would be needed)
	* or by FOO_TABLE (where a replace is already done at constant-define time)
	*/
	if (!preg_match('#^' . preg_quote($table_prefix, '#') . '#', $table_name) || !in_array($table_name, $constants, true))
	{
		$table_name = preg_replace('#^phpbb_#i', $table_prefix, $table_name);
	}

	return $table_name;
}

?>